Bug 77272

Summary: FileReader read speed is way too low
Product: WebKit Reporter: Craig Yoshioka <craigyk>
Component: DOMAssignee: Alexey Proskuryakov <ap>
Status: RESOLVED FIXED    
Severity: Normal CC: ap
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
Attachments:
Description Flags
poposed fix oliver: review+

Description Craig Yoshioka 2012-01-27 23:11:06 PST
I've found that the read speed using FileReader seems to be artifically throttled to ~8MB/sec.   The same code in Chrome gets much faster speeds (reading from an SSD, 100MB/sec+).  I know the FileReader isn't complete yet, but I thought the heads up might be nice... this speed limitation is currently the bottleneck in the resumable uploader I'm building... I've gotten the MD5 hashing speed up to 20MB/sec/thread in JS.

I'm hoping for confirmation that my interpretation is correct (that it's throttled), and to give a heads up on this performance limitation.  I recognize that FileReader in the nightly isn't production-ready yet.
Comment 1 Alexey Proskuryakov 2012-03-01 13:27:59 PST
Created attachment 129739 [details]
poposed fix
Comment 2 Alexey Proskuryakov 2012-03-01 14:51:35 PST
Committed <http://trac.webkit.org/changeset/109435>.
Comment 3 Craig Yoshioka 2012-03-02 09:23:01 PST
Wow, it's somehow magically ~512X faster now!  J/K, but it is much better,  I'm getting read speeds of ~45MB/sec now from the SSD vs. the previous ~8.  Thanks!